#############################################
# E-Blah Bulliten Board Systems        2006 #
#############################################
# Copyright (c) 2001 - 2006 E-Blah.         #
#############################################

require("$language/Load.lng");

# Quick errors for restricted areas
sub is_admin  { error("$ltxt[1]-admin-",1) if(!$members{'Administrator',$username}); }
sub is_mod    { error($ltxt[2]) if(!$members{'Administrator',$username} && !$ismod); }
sub is_member {
	if(!$memberid{$username}{'status'}) { return(); }
	elsif($memberid{$username}{'status'} eq 'ADMIN') { error("$ltxt[24] $ltxt[26]"); }
	elsif($memberid{$username}{'status'} eq 'EMAIL') { error("$ltxt[24] $ltxt[25]"); }
	elsif($memberid{$username}{'status'} eq 'EMAIL|ADMIN') { error("$ltxt[24] $ltxt[27]"); }
		else { error($ltxt[23]); }
}

sub BoardCheck {
	my($bfnd,$nump,$t);

	fopen(FILE,"$boards/bdscats.db");
	@catbase = <FILE>;
	fclose(FILE);
	chomp @catbase;

	fopen(FILE,"$boards/bdindex.db");
	@boardbase = <FILE>;
	fclose(FILE);
	chomp @boardbase;

	if($URL{'b'} eq '' && $URL{'m'} ne 'latest' && ($URL{'v'} eq '' || $URL{'v'} eq 'print') && $URL{'m'} ne '') {
		$URL{'b'} = GetMessageDatabase($URL{'m'});

		$scripturl = "$scriptname$modrewrite\lb-$URL{'b'}$usert";
		$activeusers = '';
	}

	return() if($URL{'b'} eq '');

	foreach(@boardbase) {
		($boardid,$binfo[0],$binfo[1],$binfo[2],$binfo[3],$binfo[4],$binfo[5],$binfo[6],$binfo[7],$binfo[8],$binfo[9],$binfo[10],$binfo[11],$binfo[12],$binfo[13],$binfo[14],$binfo[15]) = split("/",$_);
		if($boardid eq $URL{'b'}) { $bfnd = 1; last; }
	}

	error($ltxt[5],0,1) if !$bfnd;

	if($binfo[12] ne '') { # This board redirects, increase hits and exit
		fopen(ADD,"+<$boards/$URL{'b'}.hits");
		$nump = <ADD> || 0;
		seek(ADD,0,0);
		truncate(ADD,0);
		print ADD $nump+1,"\n";
		fclose(ADD);

		$binfo[12] =~ s/&#47;/\//g;
		redirect($binfo[12]);
	}

	# Lets start applying board permissions ...
	@mods = split(/\|/,$binfo[1]);
	foreach (@mods) {
		if($_ =~ /\((.+?)\)/ && $members{$1,$username}) { $ismod = 1; } # Member Group Mods
		if($username eq $_) { $ismod = 1; last; }
	}

	foreach (@catbase) {
		($nme,$id,$grps,$input) = split(/\|/,$_);
		if($input ne '') { @cats = split("/",$input); } else { next; }
		foreach (@cats) {
			if($_ eq $URL{'b'}) { $catid = $id; $catname = $nme; $memgrp = $grps; last; }
		}
	}

	push(@mgaccess,(split(',',$binfo[9]),split(',',$memgrp)));
	if(!GetMemberAccess($memgrp) || !GetMemberAccess($binfo[9])) { error($ltxt[5]); }

	if($binfo[6] ne '') { CoreLoad('BoardLock'); Password(); }
	if($binfo[10]) { $allowrate = 1; }

	$boardnm = $binfo[2];
}

sub GetMessageDatabase {
	my($findmessage,$newboard,$savedb) = @_;
	my($t,$boardid,$id,$returnid,$foundid,@newlist);

	if($savedb eq '') {
		fopen(FILE,"$boards/Messages.db");
		while($t = <FILE>) {
			chomp $t;
			($id,$boardid) = split(/\|/,$t);
			if($id == $findmessage) { $returnid = $boardid; last; }
		}
		fclose(FILE);
		return($returnid);
	} else {
		fopen(FILE,"+<$boards/Messages.db",1);
		while($t = <FILE>) {
			chomp $t;
			($id,$boardid) = split(/\|/,$t);
			if($id eq $findmessage && $savedb != 2) { push(@newlist,"$id|$newboard"); $foundid = 1; next; } # Change board
			elsif($id eq $findmessage && $savedb == 2) { $foundid = 1; next; } # Delete
			push(@newlist,$t);
		}
		truncate(FILE,0);
		seek(FILE,0,0);
		if(!$foundid) { print FILE "$findmessage|$newboard\n"; } # New message
		foreach $t (@newlist) { print FILE "$t\n"; }
		fclose(FILE);
	}
}

sub Mods {
	$modz = '';
	foreach(@mods) {
		if($_ =~ /\((.+?)\)/ && $permissions{$1,'name'} ne '') { $modz .= qq~<a href="$surl\lv-members/a-groups/group-$1/"><font color="$permissions{$1,'color'}">$permissions{$1,'name'}</font></a>, ~; }
			else {
				GetMemberID($_);
				if($memberid{$_}{'sn'} eq '') { next; }
				$modz .= "$userurl{$_}, ";
			}
	}
	if($modz eq '') { return(); }
	$modz =~ s/, \Z//gi;
}

sub StarCreator {
	my($starr);
	my($input) = @_;
	if($permissions{$input,'starcount'} < 1 || $permissions{$input,'starcount'} > 51) { $permissions{$input,'starcount'} = 1; }
	if($permissions{$input,'star'} eq '') { return(); }
	for($g = 0; $g < $permissions{$input,'starcount'}; $g++) { $starr .= qq~<img src="$images/$permissions{$input,'star'}" alt="" />~; }
	return($starr);
}

sub loaduserdisplay {
	my($user) = $_[0];
	my($memberstar,$memberpic,$membericq,$memberskype,$memberaim,$membermsn,$memberpost,$ppd,$memberyim,$stpuser,$admintext);

	GetMemberID($user);
	$guest = 0;
	if($memberid{$user}{'sn'} eq '') {
		$membername = CensorList($user);
		$membername =~ s/ \(Guest\)\Z//gis;
		$mprofile = qq~<div class="center">$gtxt{'0'}<br /><br /><br /><br /></div>~;
		$instmsg = '';
		$guest = 1;
		return;
	}

	if($divstart eq '') {
		$divstart = !$fancyqprofile ? ':</strong> ' : qq~</strong><div class="win" style="padding: 3px;">~;
		$divstop  = !$fancyqprofile ? '<br />' : '</div>';
	}

	$lastactive{$user} = get_date($memberid{$user}{'lastactive'},1);

	# Get the group apart of, and stars ...
	$memberstar = $memberstat = $team = '';
	foreach(@grpsposts) {
		($num,$memgrp) = split(/\|/,$_);
		if($memberid{$user}{'posts'} >= $num) {
			$memberstat = $permissions{$memgrp,'name'};
			$memberstar = StarCreator($memgrp);
		}
	}

	$permissions{$membergrp{$user},'level'} = $permissions{$membergrp{$user},'level'} <= 0 ? ($permissions{'Moderators','level'}+1) : $permissions{$membergrp{$user},'level'};
	foreach(@mods) {
		if($permissions{'Moderators','level'} && $user eq $_ && $permissions{$membergrp{$user},'level'} >= $permissions{'Moderators','level'}) {
			$membergrp{$user} = 'Moderators';
			last;
		}
	}

	if($membergrp{$user} ne '') {
		if($permissions{$membergrp{$user},'team'}) { $team = 1; }
		$memberstat = $permissions{$membergrp{$user},'name'};
		if($permissions{$membergrp{$user},'star'}) { $memberstar = StarCreator($membergrp{$user}); }
	}

	$membername = $userurl{$user};

	# Avatar
	if(!$memberid{$username}{'ownavatar'} && $memberid{$user}{'avatar'} ne '' && $apic) {
		$pic = $memberid{$user}{'avatar'};
		if($memberid{$user}{'avatarsize'}) { ($height,$width) = split(/\|/,$memberid{$user}{'avatarsize'}); }
			else { $width = $picwidth; $height = $picheight; }
		if($memberid{$user}{'avatar'} =~ /http:/ || $memberid{$user}{'avatarupload'}) { $memberpic = qq~<img src="$pic" width="$width" height="$height" alt="" />~; }
			else { $memberpic = qq~<img src="$avsurl/$memberid{$user}{'avatar'}" alt="" />~; }
	}

	# E-mail address
	$memberemail = $memberid{$user}{'hidemail'} && $hmail && !$members{'Administrator',$username} ? '' : qq~<a href="mailto:$memberid{$user}{'email'}">$img{'email'}</a>$msp2~;

	# Post count
	if(!$hideposts) { $memberpost = qq~<strong style="line-height: 150%;">$ltxt[9]$divstart~.MakeComma($memberid{$user}{'posts'}).$divstop; }

	# Instant Messanging
	if($memberid{$user}{'aim'})  { $memberaim = qq~$msp2<a href="aim:goim?screenname=$memberid{$user}{'aim'}&amp;message=You+there?" title="$ltxt[10] ($memberid{$user}{'aim'})">$img{'aim'}</a>~; }
	if($memberid{$user}{'msn'}) { $membermsn = qq~$msp2<a href="http://members.msn.com/$memberid{$user}{'msn'}" target="msn" title="$memberid{$user}{'msn'}">$img{'msn'}</a>~; }
	if($memberid{$user}{'icq'})  { $membericq = qq~$msp2<a href="http://www.icq.com/whitepages/wwp.php?to=$memberid{$user}{'icq'}" target="_blank" title="$memberid{$user}{'icq'}">$img{'icq'}</a>~; }
	if($memberid{$user}{'yim'}) { $memberyim = qq~$msp2<a href="http://profiles.yahoo.com/$memberid{$user}{'yim'}" target="yim" title="$memberid{$user}{'yim'}">$img{'yim'}</a>~; }
	if($memberid{$user}{'skype'}) { $memberskype = qq~$msp2<a href="skype:$memberid{$user}{'skype'}" target="skype" title="$memberid{$user}{'skype'}">$img{'skype'}</a>~; }

	if(!$memberid{$username}{'showsig'} && $maxsig > 0 && $memberid{$user}{'sig'}) { # Signature
		$extra = qq~<tr><td><br /><br /></td></tr><tr><td class="postbody"><div class="messageseps smalltext">~.BC($memberid{$user}{'sig'})."</div></td></tr>";
	}

	if($showgender) { # Gender
		if($memberid{$user}{'sex'} == 1) { $pic = "male"; $gen = $ltxt[11]; }
		elsif($memberid{$user}{'sex'} == 2) { $pic = "female"; $gen = $ltxt[12]; }
		$gender = qq~<strong>$ltxt[22]$divstart<img src="$images/$pic.gif" alt="" /> $gen$divstop~;
		if(!$memberid{$user}{'sex'}) { $gender = ''; }
	}

	if($sppd) { # Posts Per Day
		($t,$t,$t,$lday,$lmonth,$lyear,$lweek) = localtime($memberid{$user}{'registered'});
		($t,$t,$t,$cday,$cmonth,$cyear,$cweek) = localtime(time);
		$lyear = substr($lyear,-2);
		$cyear = substr($cyear,-2);
		++$lmonth; ++$cmonth;
		$reg = (365*$lyear)+(30.42*$lmonth)+$lday;
		$now = (365*$cyear)+(30.42*$cmonth)+$cday;
		$days = ($now-$reg) || 1;
		$ppd = sprintf(qq~<strong>$ltxt[13]$divstart %.2f~, $memberid{$user}{'posts'}/$days).$divstop;
	}

	if($enablerep) { # Reputation
		$reputation = '';
		if($memberid{$user}{'rep'} ne '') {
			$color = '';
			if($memberid{$user}{'rep'} < 50) { $color = 'redrep'; } # Horrible
			elsif($memberid{$user}{'rep'} > 75) { $color = 'greenrep'; } # Best
				else { $color = 'grayrep'; } # Neut

			$reputation = qq~<strong>$gtxt{'rep'}$divstart<span class="$color">$memberid{$user}{'rep'}%</span>$divstop~;
		}
	}

	$avatar = $memberpic || $memberid{$user}{'personaltxt'} ? "$memberpic<br />$memberid{$user}{'personaltxt'}" : '';
	$showlocationu = $showlocation && $memberid{$user}{'location'} ne '' ? qq~<strong>$ltxt[41]$divstart$memberid{$user}{'location'}$divstop~ : '';

	$memberstar = qq~<div>$memberstar</div>~ if $memberstar;

	if($team) { $memberstat = "<strong>$memberstat</strong>"; }
	$admintext = "<br />$memberid{$user}{'admintxt'}" if $memberid{$user}{'admintxt'};

	$memberstat = qq~<div style="line-height: 200%" class="center">$memberstat$admintext<br />$memberstar<br />$avatar</div><br />~ if($memberstat || $memberstar || $avatar);

	($t1,$t2) = split(/\|/,$memberid{$user}{'rndsid'});
	$timeon = '';
	if($showloggedon && ($t1 > 60)) {
		$days = '';
		$timeon = '';
		$days  = int($t1/86400);
		$hours = int($t1/3600)-($days*24);
		$mins  = int($t1/60)-(($hours+($days*24))*60);

		$days  = $days ? " $days $ltxt[43]" : '';
		$hours = $hours ? " $hours $gtxt{'3'}" : '';
		$mins  = $mins ? " $mins $gtxt{'2'}" : '';
		$timeon = qq~<strong>$ltxt[42]$divstart$days$hours$mins$divstop~;
	}

	$mprofile = qq~$memberstat<div style="line-height: 140%; padding: 3px;">$gender$showlocationu$memberpost$ppd$timeon$reputation</div>~;
	$instmsg  = "$membericq$memberaim$memberyim$membermsn$memberskype";
}

sub LogPage {
	if($username eq 'Guest') { return(); }
	my($lid,$ltime,$found,$lltime);

	$lltime = (time+2); # +2 prevents "Your New Post == New".

	fopen(ULOG,"$members/$username.log");
	while($log = <ULOG>) {
		chomp $log;
		($lid,$ltime) = split(/\|/,$log);
		$logged{$lid} = $ltime;
		$tempwrite .= "$log\n" if($lid ne $URL{'m'} && $lid ne $URL{'b'} && $ltime+($logdays*86400) > time);
	}
	fclose(ULOG);

	fopen(ULOG,"+>$members/$username.log");
	print ULOG "$URL{'m'}|$lltime\n" if($URL{'m'} ne '');
	if($_[0]) { $lltime = 0; }
	print ULOG "$URL{'b'}|$lltime\n$tempwrite";
	fclose(ULOG);
}

sub LMGS {
	if($members{'Administrator',$username}) { return(); }
	foreach(@fullgroups) {
		if($members{$_,$username}) {
			$ipon     = $permissions{$_,'ip'} || $ipon;
			$modon    = $permissions{$_,'moderate'} || $modon;
			$ston     = $permissions{$_,'sticky'} || $ston;
			$modifyon = $permissions{$_,'modify'} || $modifyon;
			$proon    = $permissions{$_,'profile'} || $proon;
			$calmod   = $permissions{$_,'cal'} || $calmod;
		}
	}
}

sub Ban {
	fopen(FILE,"$prefs/BanList.txt");
	while(<FILE>) {
		chomp $_;
		($banstring,$banlimit,$bantime) = split(/\|/,$_);
		$length = length($banstring);
		$ipsearch = substr($ENV{'REMOTE_ADDR'},0,$length);
		if($ipsearch =~ /\Q$banstring/i || $username eq $banstring || $banstring eq $memberid{$username}{'email'}) { CoreLoad('BoardLock'); Banned($banlimit,$bantime); }
	}
	fclose(FILE);
}

sub FindRanks {
	my(@rdata);
	($frank) = $_[0];
	fopen(FILE,"$members/List.txt");
	@list = <FILE>;
	fclose(FILE);
	chomp @list;
	foreach(@list) {
		if($members{$frank,$_}) { push(@rdata,$_); }
	}
	return(@rdata);
}

sub Format {
	($temp) = $_[0];
	$temp =~ s/&/\&amp;/g;
	$temp =~ s/</&lt;/g;
	$temp =~ s/>/&gt;/g;
	$temp =~ s/\cM//g;
	$temp =~ s/\n/<br \/>/g;
	$temp =~ s/\|/\&#124;/g;
	$temp =~ s/"/\&quot;/g;
	$temp =~ s/  /&nbsp;&nbsp;/gi;
	$temp =~ s/\t/&nbsp; &nbsp; &nbsp;/gi;
	return $temp;
}

sub Unformat {
	($temp) = $_[0];
	$temp =~ s/<br \/>/\n/g;
	$temp =~ s/<br>/\n/g;     # Temporary
	$temp =~ s/&lt;/</g;
	$temp =~ s/&gt;/>/g;
	$temp =~ s/&nbsp; &nbsp; &nbsp;/\t/g; # DO THE TABS
	$temp =~ s/&nbsp;&nbsp;/  /gi;
	return $temp;
}

sub BoardProperties {
	$tallow = 0; # Thread rules start
	if($noguestp == 0 && $username eq 'Guest') { $rules .= $ltxt[30]; }
		else {
			if(GetMemberAccess($binfo[3])) { $rules .= $ltxt[31]; $tallow = 1; }
				else { $rules .= $ltxt[30]; }
		}
	if($noguestp == 0 && $username eq 'Guest') { $rules .= $ltxt[44]; }
		else {
			if(GetMemberAccess($binfo[4])) { $rules .= $ltxt[33]; $repallow = 1; }
				else { $rules .= $ltxt[44]; }
		}

	$rules .= (!GetMemberAccess($binfo[5]) || !$tallow) ? $ltxt[35] : $ltxt[34]; # Polls

	$rules .= ((($uallow eq 2 && $username ne 'Guest') || ($uallow eq 3 && $members{'Administrator',$username}) || ($uallow eq 1)) && GetMemberAccess($binfo[11])) ? $ltxt[29] : $ltxt[28];

	$rules2  = $ltxt[36];
	$rules2 .= $html ? $ltxt[37] : $ltxt[38];
	$rules2 .= $ltxt[39];
	$rules2 .= $BCLoad ? $ltxt[37] : $ltxt[38];
	$rules2 .= $ltxt[40];
	$rules2 .= $BCSmile ? $ltxt[37] : $ltxt[38];
}

sub ListBoards {
	if(!$boardbase[1]) { return(qq~<span class="smalltext">$boardnm ($ltxt[19])</span>~); }

	foreach(@catbase) {
		($t,$boardid,$memgrps,$t,$t,$subcats) = split(/\|/,$_);
		$catbase{$boardid} = $_;
		if(!GetMemberAccess($memgrps)) { next; }
		foreach(split(/\//,$subcats)) { $noshow{$_} = 1; }

		$cats .= "$boardid/";
	}

	foreach(@boardbase) {
		($id,$t,$t,$t,$t,$t,$t,$passed,$t,$t,$boardgood,$t,$t,$redir) = split("/",$_);
		if(!$members{'Administrator',$username} && (!GetMemberAccess($boardgood) || $passed ne '' || $redir ne '')) { next; }
		$board{$id} = $_;
	}

	$temp = qq~<script type="text/javascript">
<!--
function JumpTo(ghere) {
 if(ghere != '') { location = "$surl\lb-"+ghere+"/"; }
}
//-->
</script>
<select name="JumpZ" onchange="JumpTo(this.value);">~;

	$scat{"$URL{'b'}"} = ' selected="selected"';
	SubCatsList($cats,1);
	return($temp."</select>");
}

sub SubCatsList {
	foreach $catbased (split(/\//,$_[0])) {
		if($arshown{$catbased} || $catbase{$catbased} eq '') { next; }
		if($noshow{$catbased} && $_[1]) { next; }
		$arshown{$catbased} = 1;

		($b,$bid,$t,$input,$t,$subcats) = split(/\|/,$catbase{$catbased});

		$temp .= qq~<optgroup label="$_[2]$b">~;
		if($input ne '') {
			foreach $boardbased (split(/\//,$input)) {
				if($board{$boardbased} eq '') { next; }
				($obds,$t,$t,$info) = split("/",$board{$boardbased});
				$temp .= qq~<option value="$obds"$scat{$obds}>$_[2]$info</option>~;
			}
		}

		$temp .= "</optgroup>";
		if($subcats ne '') { SubCatsList($subcats,0,"$_[2]&nbsp; &nbsp; "); }
	}
}

sub FindStatus {
	my($temp);
	if($type) { $temp = 'locked'; }
	elsif($replies >= $vhtdmax) { $temp = 'veryhotthread'; }
	elsif($replies >= $htdmax) { $temp = 'hotthread'; }
		else { $temp = 'thread'; }
	if($poll && $type) { $temp = 'poll_lock'; }
	elsif($poll) { $temp = 'poll_icon'; }
	if($stickme{$messid} && $type && $temp ne 'poll_icon') { $temp = 'sticky_lock'; }
	elsif($stickme{$messid} && $temp eq 'poll_icon') { $temp = 'poll_sticky'; }
	elsif($stickme{$messid}) { $temp = 'sticky'; }
	return($temp);
}

sub CensorList {
	if($memberid{$username}{'censor'}) { return($_[0]); }

	if(!$CensorLoad) {
		fopen(CENSOR,"$prefs/Censor.txt");
		while($censor = <CENSOR>) {
			chomp $censor;
			@t = split(/\|/,$censor);
			if($t[0] ne '' && $t[1] ne '') {
				$CensorValues .= lc($t[0])."|";
				$Censor{lc($t[0])} = Unformat($t[1]);
				$Censor{lc($t[0])} =~ s/\&quot;/"/g;
			}
		}
		fclose(CENSOR);
		$CensorValues =~ s/\|\Z//g;
		$CensorLoad = 1;
	}

	$_[0] =~ s/\b($CensorValues)\b/$Censor{lc($1)}/gi;

	return($_[0]);
}

sub MakeSmall { # To make long code look like it's suppose to, do this ...
	if(!$BCLoad) { return; }
	$message =~ s/<(.[^">]*?)\Z//gsi;
	$message =~ s~\[(.[^\]]*?)\Z~~gsi;
	$message =~ s/<a href="(.[^">]*?)\Z//gsi;
	$message =~ s~\[code\](.*?)\Z~&Code~esgi;
	$message =~ s~\[quote by=(.+?) link=(.+?) date=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[quote=(.+?)\](.+?)\Z~&Quote~gsie;
	$message =~ s~\[s\](.*?)\Z~<s>$1</s>~gsi;
	$message =~ s~\[b\](.*?)\Z~<strong>$1</strong>~gsi;
	$message =~ s~\[i\](.*?)\Z~<i>$1</i>~gsi;
	$message =~ s~\[u\](.*?)\Z~<u>$1</u>~gsi;
	$message =~ s~\[size=([1-9][^\s\n<>]*?)\](.*?)\Z~<font size="$1">$2</font>~gsi;
	$message =~ s~\[pre\](.+?)\Z~<pre>$1</pre>~gsi;
	$message =~ s~\[justify\](.+?)\Z~<div style="text-align: justify">$1</div>~gsi;
	$message =~ s~\[left\](.+?)\Z~<div style="text-align: left">$1</div>~gsi;
	$message =~ s~\[right\](.+?)\Z~<div style="text-align: right">$1</div>~gsi;
	$message =~ s~\[center\](.+?)\Z~<div style="text-align: center">$1</div>~gsi;
	$message =~ s~\[face=(.+?)\](.+?)\Z~<font face="$1">$2</font>~gsi;
	$message =~ s~\[color=(.+?)\](.+?)\Z~<font color="$1">$2</font>~gsi;
	$message =~ s~\[sub\](.+?)\Z~<sub>$1</sub>~gsi;
	$message =~ s~\[sup\](.+?)\Z~<sup>$1</sup>~gsi;
	$message =~ s~\[img(.+?)\Z~~gsi;
	if($message =~ /\[list(.*?)\](.+?)\Z/) {
		$message =~ s~\[list\](.+?)\Z~<ul>$1</ul>~gsi;
		$message =~ s~\[list=([a-zA-Z|1]+?)\](.+?)\Z~<ol type="$1">$2</ol>~gsi;
		$message =~ s~\[\*\]~<li>~gsi;
	}
}

sub GetMemberAccess { # Adapted from the BoardIndex =P
	my($grpaccess,$accessuser) = @_;
	my $boot = 1;
	if($accessuser eq '') { $accessuser = $username; }
	foreach $group (split(',',$grpaccess)) {
		if($members{$group,$accessuser}) { $boot = 0; }
		$boot = 0 if(($group eq 'member' && !$lockuserout && $username ne 'Guest') || ($group eq 'guest' && $accessuser eq 'Guest') || ($group eq 'validating' && $lockuserout && $accessuser ne 'Guest'));
	}
	if($boot) { return(0); }
	return(1);
}

sub CreateGroups { # Member Groups (Version 2)
	my(%groupmembers);

	fopen(FILE,"$prefs/Ranks2.txt");
	@globalgroups = <FILE>;
	fclose(FILE);
	chomp @globalgroups;

	foreach(@globalgroups) {
		if($_ =~ /(.+?) => {/) {
			$curread = $1;
			push(@fullgroups,$1);
		}
		elsif($_ eq '}') { $curread = ''; }

		if($curread) { # Get the permissions for this group
			if($_ =~ /(.+?) = '(.+?)'/) {
				$permissions{$curread,$1} = $2;

				if($1 eq 'pcount') { push(@grpsposts,"$2|$curread"); }
			}
			elsif($_ =~ /(.+?) = \((.+?)\)/) {
				if($1 eq 'members') {
					foreach $user (split(',',$2)) {
						$members{$curread,$user} = 1;
						if($permissions{$curread,'level'} > 0 && ($permissions{$curread,'level'} < $permissions{$membergrp{$user},'level'} || $membergrp{$user} eq '')) { $membergrp{$user} = $curread; }
						++$permissions{$curread,'count'};
					}
				}
				$permissions{$curread,$1} = $2;
			}
		}
	}
	@grpsposts = sort{$a <=> $b} @grpsposts;
	LMGS();
}

sub SaveMemberID {
	my($userid) = $_[0];
	my($iddata,$item,$itemvalue,@printuser,$hasdat,$failsafe);

	if($userid eq '') { return(0); }

	%{$memberid{$userid}} = (); # Clear out any old data
	GetMemberID($userid,'force');

	while(($item,$itemvalue) = each(%addtoID)) {
		$changeid{$item} = 1;
		if($itemvalue eq '') { next; }
		push(@printuser,"$item = |$itemvalue|");
		if($item eq 'sn') { $failsafe = 1; }
	}

	$hasdat = $memberid{$userid};
	while(($item,$itemvalue) = each(%$hasdat)) {
		if($changeid{$item}) { next; }
		push(@printuser,"$item = |$itemvalue|");
		if($item eq 'sn') { $failsafe = 1; }
	}

	if($failsafe != 1) { return(); }

	if($URL{'v'} ne 'register') { rename("$members/$userid.dat","$members/$userid.bak") || return(); } # If we can't rename, then let's be safe and just not do anything ...

	fopen(SAVEMEMBERID,">$members/$userid.dat");
	foreach(@printuser) { print SAVEMEMBERID "$_\n"; }
	fclose(SAVEMEMBERID);

	if(!-s("$members/$userid.dat")) {
		unlink("$members/$userid.dat");
		rename("$members/$userid.bak","$members/$userid.dat");
	} else { unlink("$members/$userid.bak"); }

	%addtoID  = (); # Ah, this does need to be cleared ...
	%changeid = (); # Clear this too!
}

sub GetMemberID {
	my($userid,$override) = @_;
	my($iddata,$coloruser);

	if($memberid{$userid}{'password'} ne '' && $override ne 'force') { return(1); } # Check for loading info ...

	fopen(GETMEMBERID,"$members/$userid.dat") || return(0);
	while($iddata = <GETMEMBERID>) {
		chomp $iddata;
		$iddata =~ /^(.+?) = \|(.+?)\|\Z/g;
		$memberid{$userid}{$1} = $2;
	}
	fclose(GETMEMBERID);

	if($override ne 'force' && (($hiddenmail == 2 && $username eq 'Guest') || ($hiddenmail == 1))) { $memberid{$userid}{'hidemail'} = 1; }

	if($override ne 'force') { $memberid{$userid}{'sn'} = CensorList($memberid{$userid}{'sn'}); }

	$coloruser = $permissions{$membergrp{$userid},'color'} ? qq~<span class="usercolors" style="color: $permissions{$membergrp{$userid},'color'}">$memberid{$userid}{'sn'}</span>~ : $memberid{$userid}{'sn'};
	$userurl{$userid} = qq~<a href="$surl\lv-memberpanel/a-view/u-$userid/" rel="nofollow" target="_parent">$coloruser</a>~;

	return(1);
}

sub FindUsername {
	my($findusername) = $_[0];

	UserDatabase();

	$findusername =~ s/ //gsi;

	foreach(@memlist2) {
		($un,$sn) = split(/\|/,$_);
		$sn =~ s/ //gsi;
		if(lc($sn) eq lc($findusername)) { GetMemberID($un); return($un); }
	}

	return();
}
1;